Index: .gitignore
===================================================================
--- .gitignore	(revision 4a9c6b0b15eb3738897dc1635fda2e4be67414ad)
+++ .gitignore	(revision 7a9d9684385640d7e34060469440cc80940465d8)
@@ -32,2 +32,3 @@
 bitlbee.service
 bitlbee@.service
+*.pyc
Index: irc_channel.c
===================================================================
--- irc_channel.c	(revision 4a9c6b0b15eb3738897dc1635fda2e4be67414ad)
+++ irc_channel.c	(revision 7a9d9684385640d7e34060469440cc80940465d8)
@@ -757,4 +757,9 @@
 	}
 
+	if (!bu->ic->acc->prpl->add_buddy) {
+		irc_send_num(ic->irc, 482, "%s :IM protocol does not support contact list modification", ic->name);
+		return FALSE;
+	}
+
 	bu->ic->acc->prpl->add_buddy(bu->ic, bu->handle,
 	                             icc->group ? icc->group->name : NULL);
@@ -774,4 +779,9 @@
 	if (icc->type != IRC_CC_TYPE_GROUP) {
 		irc_send_num(ic->irc, 482, "%s :Kicks are only possible to fill_by=group channels", ic->name);
+		return;
+	}
+
+	if (!bu->ic->acc->prpl->remove_buddy) {
+		irc_send_num(ic->irc, 482, "%s :IM protocol does not support contact list modification", ic->name);
 		return;
 	}
Index: irc_commands.c
===================================================================
--- irc_commands.c	(revision 4a9c6b0b15eb3738897dc1635fda2e4be67414ad)
+++ irc_commands.c	(revision 7a9d9684385640d7e34060469440cc80940465d8)
@@ -330,5 +330,5 @@
 			   showed an error message, or is doing some work
 			   before the join should be confirmed. (In the
-			   latter case, the caller should take care of that
+			   latter case, the callee should take care of that
 			   confirmation.) TRUE means all's good, let the
 			   user join the channel right away. */
Index: lib/Makefile
===================================================================
--- lib/Makefile	(revision 4a9c6b0b15eb3738897dc1635fda2e4be67414ad)
+++ lib/Makefile	(revision 7a9d9684385640d7e34060469440cc80940465d8)
@@ -13,5 +13,5 @@
 
 # [SH] Program variables
-objects = arc.o base64.o canohost.o $(EVENT_HANDLER) ftutil.o http_client.o ini.o json.o json_util.o md5.o misc.o oauth.o oauth2.o proxy.o sha1.o $(SSL_CLIENT) url.o xmltree.o ns_parse.o
+objects = arc.o base64.o canohost.o $(EVENT_HANDLER) ftutil.o http_client.o ini.o md5.o misc.o oauth.o oauth2.o parson.o proxy.o sha1.o $(SSL_CLIENT) url.o xmltree.o ns_parse.o
 
 LFLAGS += -r
Index: lib/misc.c
===================================================================
--- lib/misc.c	(revision 4a9c6b0b15eb3738897dc1635fda2e4be67414ad)
+++ lib/misc.c	(revision 7a9d9684385640d7e34060469440cc80940465d8)
@@ -386,5 +386,5 @@
 }
 
-int is_bool(char *value)
+int is_bool(const char *value)
 {
 	if (*value == 0) {
@@ -412,5 +412,5 @@
 }
 
-int bool2int(char *value)
+int bool2int(const char *value)
 {
 	int i;
Index: lib/misc.h
===================================================================
--- lib/misc.h	(revision 4a9c6b0b15eb3738897dc1635fda2e4be67414ad)
+++ lib/misc.h	(revision 7a9d9684385640d7e34060469440cc80940465d8)
@@ -135,6 +135,6 @@
 G_MODULE_EXPORT void random_bytes(unsigned char *buf, int count);
 
-G_MODULE_EXPORT int is_bool(char *value);
-G_MODULE_EXPORT int bool2int(char *value);
+G_MODULE_EXPORT int is_bool(const char *value);
+G_MODULE_EXPORT int bool2int(const char *value);
 
 G_MODULE_EXPORT struct ns_srv_reply **srv_lookup(char *service, char *protocol, char *domain);
Index: lib/oauth2.c
===================================================================
--- lib/oauth2.c	(revision 4a9c6b0b15eb3738897dc1635fda2e4be67414ad)
+++ lib/oauth2.c	(revision 7a9d9684385640d7e34060469440cc80940465d8)
@@ -42,7 +42,10 @@
 #include "oauth2.h"
 #include "oauth.h"
-#include "json.h"
-#include "json_util.h"
+#include "parson.h"
 #include "url.h"
+
+#define JSON_O_FOREACH(o, k, v) \
+    const char *k; const JSON_Value *v; int __i; \
+    for (__i = 0; json_object_get_tuple(o, __i, &k, &v); __i++)
 
 char *oauth2_url(const struct oauth2_service *sp)
@@ -113,23 +116,18 @@
 }
 
-static char* oauth2_parse_error(json_value *e)
+static char* oauth2_parse_error(const JSON_Value *e)
 {
 	/* This does a reasonable job with some of the flavours of error
 	   responses I've seen. Because apparently it's not standardised. */
 
-	if (e->type == json_object) {
+	if (json_type(e) == JSONObject) {
 		/* Facebook style */
-		const char *msg = json_o_str(e, "message");
-		const char *type = json_o_str(e, "type");
-		json_value *code_o = json_o_get(e, "code");
-		int code = 0;
-
-		if (code_o && code_o->type == json_integer) {
-			code = code_o->u.integer;
-		}
-
+		const char *msg = json_object_get_string(json_object(e), "message");
+		const char *type = json_object_get_string(json_object(e), "type");
+		JSON_Value *code_o = json_object_get_value(json_object(e), "code");
+		int code = json_value_get_integer(code_o);
 		return g_strdup_printf("Error %d: %s", code, msg ? msg : type ? type : "Unknown error");
-	} else if (e->type == json_string) {
-		return g_strdup(e->u.string.ptr);
+	} else if (json_type(e) == JSONString) {
+		return g_strdup(json_string(e));
 	}
 	return NULL;
@@ -156,18 +154,18 @@
 	if (content_type && (strstr(content_type, "application/json") ||
 	                     strstr(content_type, "text/javascript"))) {
-		json_value *js = json_parse(req->reply_body, req->body_size);
-		if (js && js->type == json_object) {
-			JSON_O_FOREACH(js, k, v){
+		JSON_Value *js = json_parse_string(req->reply_body);
+		if (js && json_type(js) == JSONObject) {
+			JSON_O_FOREACH(json_object(js), k, v){
 				if (strcmp(k, "error") == 0) {
 					error = oauth2_parse_error(v);
 				}
-				if (v->type != json_string) {
+				if (json_type(v) != JSONString) {
 					continue;
 				}
 				if (strcmp(k, "access_token") == 0) {
-					atoken = g_strdup(v->u.string.ptr);
+					atoken = g_strdup(json_string(v));
 				}
 				if (strcmp(k, "refresh_token") == 0) {
-					rtoken = g_strdup(v->u.string.ptr);
+					rtoken = g_strdup(json_string(v));
 				}
 			}
